# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetApiShieldSchemaValidationSettingsResult',
    'AwaitableGetApiShieldSchemaValidationSettingsResult',
    'get_api_shield_schema_validation_settings',
    'get_api_shield_schema_validation_settings_output',
]

@pulumi.output_type
class GetApiShieldSchemaValidationSettingsResult:
    """
    A collection of values returned by getApiShieldSchemaValidationSettings.
    """
    def __init__(__self__, id=None, validation_default_mitigation_action=None, validation_override_mitigation_action=None, zone_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if validation_default_mitigation_action and not isinstance(validation_default_mitigation_action, str):
            raise TypeError("Expected argument 'validation_default_mitigation_action' to be a str")
        pulumi.set(__self__, "validation_default_mitigation_action", validation_default_mitigation_action)
        if validation_override_mitigation_action and not isinstance(validation_override_mitigation_action, str):
            raise TypeError("Expected argument 'validation_override_mitigation_action' to be a str")
        pulumi.set(__self__, "validation_override_mitigation_action", validation_override_mitigation_action)
        if zone_id and not isinstance(zone_id, str):
            raise TypeError("Expected argument 'zone_id' to be a str")
        pulumi.set(__self__, "zone_id", zone_id)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="validationDefaultMitigationAction")
    def validation_default_mitigation_action(self) -> builtins.str:
        """
        The default mitigation action used when there is no mitigation action defined on the operation
        """
        return pulumi.get(self, "validation_default_mitigation_action")

    @property
    @pulumi.getter(name="validationOverrideMitigationAction")
    def validation_override_mitigation_action(self) -> builtins.str:
        return pulumi.get(self, "validation_override_mitigation_action")

    @property
    @pulumi.getter(name="zoneId")
    def zone_id(self) -> builtins.str:
        """
        Identifier
        """
        return pulumi.get(self, "zone_id")


class AwaitableGetApiShieldSchemaValidationSettingsResult(GetApiShieldSchemaValidationSettingsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetApiShieldSchemaValidationSettingsResult(
            id=self.id,
            validation_default_mitigation_action=self.validation_default_mitigation_action,
            validation_override_mitigation_action=self.validation_override_mitigation_action,
            zone_id=self.zone_id)


def get_api_shield_schema_validation_settings(zone_id: Optional[builtins.str] = None,
                                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetApiShieldSchemaValidationSettingsResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_api_shield_schema_validation_settings = cloudflare.get_api_shield_schema_validation_settings(zone_id="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str zone_id: Identifier
    """
    __args__ = dict()
    __args__['zoneId'] = zone_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getApiShieldSchemaValidationSettings:getApiShieldSchemaValidationSettings', __args__, opts=opts, typ=GetApiShieldSchemaValidationSettingsResult).value

    return AwaitableGetApiShieldSchemaValidationSettingsResult(
        id=pulumi.get(__ret__, 'id'),
        validation_default_mitigation_action=pulumi.get(__ret__, 'validation_default_mitigation_action'),
        validation_override_mitigation_action=pulumi.get(__ret__, 'validation_override_mitigation_action'),
        zone_id=pulumi.get(__ret__, 'zone_id'))
def get_api_shield_schema_validation_settings_output(zone_id: Optional[pulumi.Input[builtins.str]] = None,
                                                     opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetApiShieldSchemaValidationSettingsResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_api_shield_schema_validation_settings = cloudflare.get_api_shield_schema_validation_settings(zone_id="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str zone_id: Identifier
    """
    __args__ = dict()
    __args__['zoneId'] = zone_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getApiShieldSchemaValidationSettings:getApiShieldSchemaValidationSettings', __args__, opts=opts, typ=GetApiShieldSchemaValidationSettingsResult)
    return __ret__.apply(lambda __response__: GetApiShieldSchemaValidationSettingsResult(
        id=pulumi.get(__response__, 'id'),
        validation_default_mitigation_action=pulumi.get(__response__, 'validation_default_mitigation_action'),
        validation_override_mitigation_action=pulumi.get(__response__, 'validation_override_mitigation_action'),
        zone_id=pulumi.get(__response__, 'zone_id')))
