# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetZeroTrustAccessKeyConfigurationResult',
    'AwaitableGetZeroTrustAccessKeyConfigurationResult',
    'get_zero_trust_access_key_configuration',
    'get_zero_trust_access_key_configuration_output',
]

@pulumi.output_type
class GetZeroTrustAccessKeyConfigurationResult:
    """
    A collection of values returned by getZeroTrustAccessKeyConfiguration.
    """
    def __init__(__self__, account_id=None, days_until_next_rotation=None, id=None, key_rotation_interval_days=None, last_key_rotation_at=None):
        if account_id and not isinstance(account_id, str):
            raise TypeError("Expected argument 'account_id' to be a str")
        pulumi.set(__self__, "account_id", account_id)
        if days_until_next_rotation and not isinstance(days_until_next_rotation, float):
            raise TypeError("Expected argument 'days_until_next_rotation' to be a float")
        pulumi.set(__self__, "days_until_next_rotation", days_until_next_rotation)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if key_rotation_interval_days and not isinstance(key_rotation_interval_days, float):
            raise TypeError("Expected argument 'key_rotation_interval_days' to be a float")
        pulumi.set(__self__, "key_rotation_interval_days", key_rotation_interval_days)
        if last_key_rotation_at and not isinstance(last_key_rotation_at, str):
            raise TypeError("Expected argument 'last_key_rotation_at' to be a str")
        pulumi.set(__self__, "last_key_rotation_at", last_key_rotation_at)

    @property
    @pulumi.getter(name="accountId")
    def account_id(self) -> builtins.str:
        """
        Identifier
        """
        return pulumi.get(self, "account_id")

    @property
    @pulumi.getter(name="daysUntilNextRotation")
    def days_until_next_rotation(self) -> builtins.float:
        """
        The number of days until the next key rotation.
        """
        return pulumi.get(self, "days_until_next_rotation")

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="keyRotationIntervalDays")
    def key_rotation_interval_days(self) -> builtins.float:
        """
        The number of days between key rotations.
        """
        return pulumi.get(self, "key_rotation_interval_days")

    @property
    @pulumi.getter(name="lastKeyRotationAt")
    def last_key_rotation_at(self) -> builtins.str:
        """
        The timestamp of the previous key rotation.
        """
        return pulumi.get(self, "last_key_rotation_at")


class AwaitableGetZeroTrustAccessKeyConfigurationResult(GetZeroTrustAccessKeyConfigurationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZeroTrustAccessKeyConfigurationResult(
            account_id=self.account_id,
            days_until_next_rotation=self.days_until_next_rotation,
            id=self.id,
            key_rotation_interval_days=self.key_rotation_interval_days,
            last_key_rotation_at=self.last_key_rotation_at)


def get_zero_trust_access_key_configuration(account_id: Optional[builtins.str] = None,
                                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZeroTrustAccessKeyConfigurationResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_access_key_configuration = cloudflare.get_zero_trust_access_key_configuration(account_id="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str account_id: Identifier
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('cloudflare:index/getZeroTrustAccessKeyConfiguration:getZeroTrustAccessKeyConfiguration', __args__, opts=opts, typ=GetZeroTrustAccessKeyConfigurationResult).value

    return AwaitableGetZeroTrustAccessKeyConfigurationResult(
        account_id=pulumi.get(__ret__, 'account_id'),
        days_until_next_rotation=pulumi.get(__ret__, 'days_until_next_rotation'),
        id=pulumi.get(__ret__, 'id'),
        key_rotation_interval_days=pulumi.get(__ret__, 'key_rotation_interval_days'),
        last_key_rotation_at=pulumi.get(__ret__, 'last_key_rotation_at'))
def get_zero_trust_access_key_configuration_output(account_id: Optional[pulumi.Input[builtins.str]] = None,
                                                   opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetZeroTrustAccessKeyConfigurationResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_cloudflare as cloudflare

    example_zero_trust_access_key_configuration = cloudflare.get_zero_trust_access_key_configuration(account_id="023e105f4ecef8ad9ca31a8372d0c353")
    ```


    :param builtins.str account_id: Identifier
    """
    __args__ = dict()
    __args__['accountId'] = account_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('cloudflare:index/getZeroTrustAccessKeyConfiguration:getZeroTrustAccessKeyConfiguration', __args__, opts=opts, typ=GetZeroTrustAccessKeyConfigurationResult)
    return __ret__.apply(lambda __response__: GetZeroTrustAccessKeyConfigurationResult(
        account_id=pulumi.get(__response__, 'account_id'),
        days_until_next_rotation=pulumi.get(__response__, 'days_until_next_rotation'),
        id=pulumi.get(__response__, 'id'),
        key_rotation_interval_days=pulumi.get(__response__, 'key_rotation_interval_days'),
        last_key_rotation_at=pulumi.get(__response__, 'last_key_rotation_at')))
